﻿local ADDONNAME, RepperData = ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")
RepperData.Functions = {}
local MyFuncs = RepperData.Functions;
local _;

-- Variables
local showEvent = false;
local trackRepCheckBox = nil;
local RepList = {};
local variablesLoaded = false

-- Slash Commands
SLASH_Repper1 = '/repper'

function Repper_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");						--AddOn Loaded
	self:RegisterEvent("PLAYER_ENTERING_WORLD");			--Player Loaded
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");	--Faction Update
	self:RegisterEvent("CHAT_MSG_SYSTEM");					--New Faction Added
	self:RegisterEvent("QUEST_LOG_UPDATE");					--New Faction Added
	
	--self:RegisterAllEvents()
end

-- Event Handler
function Repper_OnEvent(self, event, ...)
	-- Starts the addon
	if showEvent then print(event) end
	if (event == "ADDON_LOADED") then
		if (...) == ADDONNAME then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..ADDONNAME.." ".."|cffff0000"..VERSION.."|cff00ff00: Loaded.");
			RepList = CopyTable(RepperSVPC)
			if RepList ~= nil then
				for k,v in pairs(RepList) do 
					v.Frame = CreateFrame("StatusBar", k, REPPERFrame,"RBarTemplate")
				end
			end
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		variablesLoaded = true;
	end
	MyFuncs.Update()
end

function Repper_CheckBox()
	local name = GetFactionInfo(GetSelectedFaction())
	if RepList[name] ~= nil then
		RepList[name].Tracked = trackRepCheckBox:GetChecked()
	else
		RepList[name] = {Tracked = true, Amount = 0, Max = 0, Frame = CreateFrame("StatusBar", name, REPPER,"RBarTemplate")}
	end
	MyFuncs.Update()
end

function MyFuncs.Update()
	if not variablesLoaded then return end;
	local lastFrame = nil
	REPPER:SetHeight(15);
	for k,v in pairs(RepList) do 
		local name, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = MyFuncs.GetFactionInfoByName(k)
		local barVal = earnedValue-bottomValue;
		local barMax = topValue-bottomValue;
		if (barMax == 0) then
			barVal = 1;
			barMax = 1;
		end
		if v.Tracked then
			RepList[name].Frame:Show()
			RepList[name].Frame.Text:SetText(name)
			RepList[name].Frame.Status:SetText(topValue-earnedValue);
			RepList[name].Frame:SetMinMaxValues(0,barMax);
			RepList[name].Frame:SetValue(barVal);
			RepList[name].Frame:SetStatusBarColor(FACTION_BAR_COLORS[standingId].r, FACTION_BAR_COLORS[standingId].g, FACTION_BAR_COLORS[standingId].b );
			if lastFrame == nil then
				RepList[name].Frame:SetPoint("TOPLEFT", REPPER, "TOPLEFT", 11,-9)
			else
				RepList[name].Frame:SetPoint("TOPLEFT", lastFrame, "BOTTOMLEFT", 0,-4)
			end
			lastFrame = RepList[name].Frame
			REPPER:SetHeight(REPPER:GetHeight()+16);
		else 
			RepList[name].Frame:Hide()
		end
	end
	if REPPER:GetHeight() <= 15 then
		REPPER:Hide()
	else
		REPPER:Show()
	end
	RepperSVPC = CopyTable(RepList)
end

function MyFuncs.GetFactionInfoByName(name)
	local count = 1
	local collapsed = {}
	local result = nil;
	local FactionName, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild
	-- Scan RepFrame and expand headers until found
	while GetFactionInfo(count) ~= nil do
		FactionName, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild = GetFactionInfo(count)
		-- If found
		if FactionName == name then break; end
		-- If not found
		if isHeader and isCollapsed then
			ExpandFactionHeader(count)
			-- Record which headers get expanded
			collapsed[count] = true
		end
		count = count + 1
	end
	-- Recollapse any header we expanded
	for i = count, 1, -1 do
		if collapsed[i] == true then CollapseFactionHeader(i) end
	end
	--return the data
	return FactionName, description, standingId, bottomValue, topValue, earnedValue, atWarWith, canToggleAtWar, isHeader, isCollapsed, hasRep, isWatched, isChild;
end

function MyFuncs.OnClick(self)
	if IsShiftKeyDown() then 
		-- Untrack This Rep
		RepList[self.Text:GetText()].Tracked = false
		MyFuncs.Update()
	end

end

function MyFuncs.HookDetailOnUpdate() 
	local name = GetFactionInfo(GetSelectedFaction())
	if RepList[name] ~= nil then
		trackRepCheckBox:SetChecked(RepList[name].Tracked)
	else
		trackRepCheckBox:SetChecked(false)
	end
	ReputationDetailFrame:SetHeight(225)
end
function MyFuncs.HookDetailOnShow() 
	if trackRepCheckBox==nil then
		trackRepCheckBox = CreateFrame("CheckButton", "trackRepCheckBox", ReputationDetailFrame, "OptionsSmallCheckButtonTemplate" )
		trackRepCheckBox:SetPoint("TOPLEFT" , ReputationDetailMainScreenCheckBox, "BOTTOMLEFT", 0, 4)
		trackRepCheckBox:SetSize(26,26)
		_G[trackRepCheckBox:GetName().."Text"]:SetText("Track with |cff20B020MiniHUD|r");
		trackRepCheckBox:SetScript("OnClick", Repper_CheckBox)
		trackRepCheckBox:Show()
	end
end

function SlashCmdList.Repper(msg)
	if (msg == '') then
		print('Repper: No Commands available yet.');
	--elseif (msg == 'none') then
	--	print('Repper: Disabling all tracking');
		-- ExpandAllFactionHeaders();
		-- for i = 1, GetNumFactions() do
			-- AllFactions[i].CheckBox:SetChecked(false);
			-- local FactionName = GetFactionInfo(i);
			-- FactionsByName[FactionName].checked = false;
		-- end
		-- MyFuncs.Update()
	elseif (msg == 'on') then
		showEvent = true;
	elseif (msg == 'off') then
		showEvent = false;
	end
end


_G[ADDONNAME] = MyFuncs -- put our functions in the global environment under our addon name so we can access them from the .xml as ProfessionHUD.FunctionName

ReputationDetailFrame:HookScript("OnShow", Repper.HookDetailOnShow)
ReputationDetailFrame:HookScript("OnUpdate", Repper.HookDetailOnUpdate)


	-- -----------------------------------------------------------------------------------------
	-- --Keep for scroll frame example
	-- -----------------------------------------------------------------------------------------
	
	-- --Create Config Frame
	-- TrackingConfig = CreateFrame("Frame", "TrackingConfig", UIParent, "UIPanelDialogTemplate");
	-- TrackingConfig:SetSize(340,500);
	-- TrackingConfig:SetPoint("CENTER");--, anchorpoint, relativeTo, relativePoint);
	-- TrackingConfig:SetMovable(true);
	-- TrackingConfig:SetScript("OnMouseDown", TrackingConfig.StartMoving)
	-- TrackingConfig:SetScript("OnMouseUp", TrackingConfig.StopMovingOrSizing)
	-- --Set Config Frame Title
	-- TrackingConfig.Title:SetFontObject("GameFontHighlight");
	-- TrackingConfig.Title:ClearAllPoints();
	-- TrackingConfig.Title:SetPoint("TOPLEFT",TrackingConfigTitleBG,"TOPLEFT" , 6, -2);
	-- TrackingConfig.Title:SetText("Rep Tracking");
	-- --Set Scroll Frame
	-- TrackingConfig.ScrollFrame = CreateFrame("ScrollFrame", nil, TrackingConfig, "UIPanelScrollFrameTemplate");
	-- TrackingConfig.ScrollFrame:SetPoint("TOPLEFT", TrackingConfigDialogBG, "TOPLEFT", 4,-8);
	-- TrackingConfig.ScrollFrame:SetPoint("BOTTOMRIGHT", TrackingConfigDialogBG, "BOTTOMRIGHT", -25,4);
	-- TrackingConfig.ScrollChild = CreateFrame("Frame", nil, TrackingConfig.ScrollFrame);
	-- TrackingConfig.ScrollFrame:SetScrollChild(TrackingConfig.ScrollChild);
	-- TrackingConfig:Hide();
-- end